// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /// Use this method to get a list of administrators in a chat. On success, returns an Array of ChatMember objects that contains information about all chat administrators except other bots. If the chat is a group or a supergroup and no administrators were appointed, only the creator will be returned.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target supergroup or channel (in the format @channelusername)
    /// - Returns: Future<[ChatMember]>. Throws on errors.
    /// - Note: Asynchronous method.
    ///
    /// [- SeeAlso: ]<https://core.telegram.org/bots/api#getchatadministrators>

    public struct GetChatAdministratorsParams: JSONEncodable {
        var chatId: ChatId

        enum CodingKeys: String, CodingKey {
            case chatId = "chat_id"
        }

        public init(chatId: ChatId) {
            self.chatId = chatId
        }
    }

    @discardableResult
    public func getChatAdministrators(params: GetChatAdministratorsParams) throws -> Future<[ChatMember]> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        let response: Future<TelegramContainer<[ChatMember]>>
        response = try client.respond(endpoint: "getChatAdministrators", body: body, headers: headers)
        return response.flatMap(to: [ChatMember].self) { try self.wrap($0) }
    }
}
