// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /// Use this method to change the description of a supergroup or a channel. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - description: New chat description, 0-255 characters
    /// - Returns: Future<Bool>. Throws on errors.
    /// - Note: Asynchronous method.
    ///
    /// [- SeeAlso: ]<https://core.telegram.org/bots/api#setchatdescription>

    public struct SetChatDescriptionParams: JSONEncodable {
        var chatId: ChatId
        var description: String?

        enum CodingKeys: String, CodingKey {
            case chatId = "chat_id"
            case description = "description"
        }

        public init(chatId: ChatId, description: String? = nil) {
            self.chatId = chatId
            self.description = description
        }
    }

    @discardableResult
    public func setChatDescription(params: SetChatDescriptionParams) throws -> Future<Bool> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        let response: Future<TelegramContainer<Bool>>
        response = try client.respond(endpoint: "setChatDescription", body: body, headers: headers)
        return response.flatMap(to: Bool.self) { try self.wrap($0) }
    }
}
