// Telegrammer - Telegram Bot Swift SDK.
// This file is autogenerated by API/generate_wrappers.rb script.


import HTTP

public extension Bot {

    /// Use this method to set a new profile photo for the chat. Photos can't be changed for private chats. The bot must be an administrator in the chat for this to work and must have the appropriate admin rights. Returns True on success.
    /// Note: In regular groups (non-supergroups), this method will only work if the ‘All Members Are Admins’ setting is off in the target group.
    /// - Parameters:
    ///     - chat_id: Unique identifier for the target chat or username of the target channel (in the format @channelusername)
    ///     - photo: New chat photo, uploaded using multipart/form-data
    /// - Returns: Future<Bool>. Throws on errors.
    /// - Note: Asynchronous method.
    ///
    /// [- SeeAlso: ]<https://core.telegram.org/bots/api#setchatphoto>

    public struct SetChatPhotoParams: MultipartEncodable {
        var chatId: ChatId
        var photo: InputFile

        enum CodingKeys: String, CodingKey {
            case chatId = "chat_id"
            case photo = "photo"
        }

        public init(chatId: ChatId, photo: InputFile) {
            self.chatId = chatId
            self.photo = photo
        }
    }

    @discardableResult
    public func setChatPhoto(params: SetChatPhotoParams) throws -> Future<Bool> {
        let body = try httpBody(for: params)
        let headers = httpHeaders(for: params)
        let response: Future<TelegramContainer<Bool>>
        response = try client.respond(endpoint: "setChatPhoto", body: body, headers: headers)
        return response.flatMap(to: Bool.self) { try self.wrap($0) }
    }
}
